## libthrust 1.4.0

=== debian/changelog ===
libthrust (1.4.0-1) unstable; urgency=low

  * Initial release.  (Closes: #628195)

 -- Andreas Beckmann <debian@abeckmann.de>  Sat, 28 May 2011 09:32:48 +0200

## libthrust 1.9.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(Thrust CXX)

set(CMAKE_SKIP_INSTALL_ALL_DEPENDENCY true)

file(READ "thrust/version.h" thrust_version_file)
string(REGEX MATCH "THRUST_VERSION ([0-9]+)" DUMMY ${thrust_version_file})
set(thrust_version ${CMAKE_MATCH_1})
#message("thrust_version= ${thrust_version}")
math(EXPR Thrust_VERSION_MAJOR "(${thrust_version} / 100000)")
math(EXPR Thrust_VERSION_MINOR "(${thrust_version} / 100) % 1000")
math(EXPR Thrust_VERSION_PATCH " ${thrust_version} % 100")

message(STATUS "Thrust version ${Thrust_VERSION_MAJOR}.${Thrust_VERSION_MINOR}.${Thrust_VERSION_PATCH}")


include(CTest)
enable_testing()

function(print_flags flags)
  message("${flags}:")
  set(flags ${${flags}})
  set(__is_name True)
  foreach(arg ${flags})
    if (__is_name)
      set(__arg_name ${arg})
      set(__is_name False)
    else()
      separate_arguments(arg)
      set(arg ${arg})
      message(" | ${__arg_name} : '${arg}'")
      set(__is_name True)
    endif()
  endforeach()
endfunction()


set(
  GNU_COMPILER_FLAGS
  WARN_ALL             "-Wall"
  WARNINGS_AS_ERRORS   "-Werror"
  RELEASE              "-O2"
  DEBUG                "-g"
  EXCEPTION_HANDLING   " "
  CPP                  " "
  OMP                  "-fopenmp"
  TBB                  " "
  CUDA                 " "
  CUDA_BULK          " "
  WORKAROUNDS          " "
  C++03                " "
  C++11                "-std=c++11"
  )
set(
  GNU_LINKER_FLAGS
  DEBUG " "
  RELEASE " "
  WORKAROUNDS " "
  CPP " "
  OMP "-fopenmp"
  TBB " "
  CUDA " "
  CUDA_BULK " "
  )

set(
  CLANG_COMPILER_FLAGS
  WARN_ALL             "-Wall"
  WARNINGS_AS_ERRORS   "-Werror"
  RELEASE              "-O2"
  DEBUG                "-g"
  EXCEPTION_HANDLING   " "
  CPP                  " "
  OMP                  "-fopenmp"
  TBB                  " "
  CUDA                 " "
  CUDA_BULK            " "
  WORKAROUNDS          " "
  C++03                " "
  C++11                "-std=c++11"
  )
set(
  CLANG_LINKER_FLAGS
  DEBUG " "
  RELEASE " "
  WORKAROUNDS " " #-stdlib=libstdc++"
  CPP " "
  OMP "-fopenmp"
  TBB " "
  CUDA " "
  CUDA_BULK " "
  )

set(
  MSVC_COMPILER_FLAGS
  WARN_ALL             "/Wall"
  WARNINGS_AS_ERRORS   "/Wx"
  RELEASE              "/Ox"
  DEBUG                "/Zi -D_DEBUG /MTd"
  EXCEPTION_HANDLING   "/EHsc"
  CPP                  " "
  OMP                  "/openmp"
  TBB                  " "
  CUDA                 " "
  CUDA_BULK            " "
  WORKAROUNDS          "/DNOMINMAX /wd4503"
  C++03                " "
  C++11                "-std=c++11"
  )
set(
  MSVC_LINKER_FLAGS
  DEBUG                "/debug"
  RELEASE              " "
  WORKAROUND           "/nologo"
  CPP                  " "
  OMP                  "/openmp"
  TBB                  " "
  CUDA                 " "
  CUDA_BULK            " "
  WORKAROUNDS          " "
  )

set(NV_LINKER_FLAGS ${GNU_LINKER_FLAGS})

print_flags(MSVC_COMPILER_FLAGS)


function(add_option OPTION_NAME DESCRIPTION TYPE)
  if (${ARGC} EQUAL 3)
    message(FATAL_ERROR "No option value [list] is provided")
  endif()
  if (${OPTION_NAME} AND "x${TYPE}" STREQUAL "xSTRING")
    LIST(FIND ARGN ${${OPTION_NAME}} index)
    if (index EQUAL -1)
      message(FATAL_ERROR "Invalid value '${${OPTION_NAME}}' for '${DESCRIPTION}'")
    endif()
  endif()
  set(value_list ${ARGN})
  LIST(GET value_list  0 default_value)
  LIST(SORT value_list)
  set(${OPTION_NAME} ${default_value} CACHE ${TYPE} ${DESCRIPTION})
  if ("x${TYPE}" STREQUAL "xSTRING")
    set_property(CACHE ${OPTION_NAME} PROPERTY STRINGS ${value_list})
  endif()
endfunction()

add_option(CUDA_ARCH  "Compute capability code generation" STRING sm_61
  sm_30 sm_32 sm_35 sm_37
  sm_50 sm_52 sm_61)
add_option(HOST_BACKEND   "The host   backend to target" STRING CPP OMP TBB)
add_option(DEVICE_BACKEND "The device backend to target" STRING CUDA CUDA_BULK CPP OMP TBB)
add_option(CUDA_CDP "Enable CUDA dynamic parallelism" BOOL False)
add_option(CXX_STD "C++ standard" STRING C++03 C++11)
add_option(THRUST_MODE "Release versus debug mode" STRING RELEASE DEBUG)

if (WIN32)
  set(WINNT True)
  set(NOT_WINNT False)
  add_option(MSVC_VERSION "MS Visual C++ version" STRING NONE 8.0 9.0 10.0 11.0 12.0 13.0 1900)
else()
  set(WINNT False)
  set(NOT_WINNT True)
endif()
add_option(WARN_ALL "Enable all compilation warnings" BOOL ${NOT_WINNT})
add_option(WARN_ERROR "Treat warnings as errors" BOOL ${NOT_WINNT})

IF(NOT CMAKE_BUILD_TYPE)
  # possible cmake bug (?) : RelWithDebInfo passes -DNDEBUG
    SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# Helpers
macro(set_thrust_flags THRUST_FLAGS_)
  set(${THRUST_FLAGS_} "-DTHRUST_HOST_SYSTEM=THRUST_HOST_SYSTEM_${HOST_BACKEND}")
  LIST(APPEND ${THRUST_FLAGS_} "-DTHRUST_DEVICE_SYSTEM=THRUST_DEVICE_SYSTEM_${DEVICE_BACKEND}")

  if (THRUST_MODE STREQUAL "DEBUG")
    LIST(APPEND ${THRUST_FLAGS_} "-DTHRUST_DEBUG")
  endif()
endmacro()

macro(get_compiler_id COMPILER_ID_)
  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    set(${COMPILER_ID_} "GNU")
  elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(${COMPILER_ID_} "CLANG")
  elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
    set(${COMPILER_ID_} "CLANG")
  elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    set(${COMPILER_ID_} "Intel")
  elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    set(${COMPILER_ID_} "MSVC")
  elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "PGI")
    set(${COMPILER_ID_} "PGI")
  endif()
endmacro()

macro(find_key_value LIST_ KEY_ VALUE_)
  LIST(FIND ${LIST_} ${KEY_}  index_)
  if (index_ EQUAL -1) 
    message(FATAL_ERROR "${KEY_} is not found in ${LIST_}." )
  endif()
  math(EXPR index_ "${index_}+1")
  LIST(GET ${LIST_} ${index_} ${VALUE_})
  separate_arguments(${VALUE_})
endmacro()

macro(set_cc_compiler_flags CC_COMPILER_FLAGS_)
  get_compiler_id(CXX_)
  set(CXX_ ${CXX_}_COMPILER_FLAGS)

  find_key_value(${CXX_} EXCEPTION_HANDLING flags_)
  LIST(APPEND ${CC_COMPILER_FLAGS_} ${flags_})

  find_key_value(${CXX_} ${HOST_BACKEND} flags_)
  LIST(APPEND ${CC_COMPILER_FLAGS_} ${flags_})
  
  find_key_value(${CXX_} ${DEVICE_BACKEND} flags_)
  LIST(APPEND ${CC_COMPILER_FLAGS_} ${flags_})

  if (${WARN_ALL})
    find_key_value(${CXX_} WARN_ALL flags_)
    LIST(APPEND ${CC_COMPILER_FLAGS_} ${flags_})
  endif()
  
  if (${WARN_ERROR})
    find_key_value(${CXX_} WARNINGS_AS_ERRORS flags_)
    LIST(APPEND ${CC_COMPILER_FLAGS_} ${flags_})
  endif()

  find_key_value(${CXX_} ${CXX_STD} flags_)
  LIST(APPEND ${CC_COMPILER_FLAGS_} ${flags_})
endmacro()

macro(set_nv_compiler_flags NV_COMPILER_FLAGS_)
  set(MACHINE_ARCH_ ${CUDA_ARCH})
  # Transform sm_XX to compute_XX
  string(REGEX REPLACE "sm" "compute"  VIRTUAL_ARCH_ ${MACHINE_ARCH_})
  # Produce -gencode flags like this: -gencode=arch=compute_XX,code=\"sm_XX,compute_XX\"
  LIST(APPEND ${NV_COMPILER_FLAGS_} "-gencode=arch=${VIRTUAL_ARCH_},\\\"code=${MACHINE_ARCH_},${VIRTUAL_ARCH_}\\\"")

  if ("${THRUST_MODE}" STREQUAL "DEBUG")
    # turn on debug mode
    # XXX make this work when we've debugged nvcc -G
#    LIST(APPEND ${NV_COMPILER_FLAGS_} "-G")    
  endif()

  if ((NOT "${DEVICE_BACKEND}" STREQUAL "CUDA") AND (NOT "${DEVICE_BACKEND}"  STREQUAL "CUDA_BULK"))
    LIST(APPEND ${NV_COMPILER_FLAGS_} "--x=c++")
  endif()

  if (${CUDA_CDP})
#    LIST(APPEND ${NV_COMPILER_FLAGS_} "-rdc=true")
  endif()

  # Untested on OSX 10.8.*
  if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    if ("${CMAKE_SYSTEM_VERSION}" STREQUAL "10.8.")
      LIST(APPEND ${NV_COMPILER_FLAGS_} "-ccbin ${CMAKE_CXX_COMPILER}")
    endif()
  endif()
endmacro()

macro(set_linker_flags LINKER_FLAGS_)
  get_compiler_id(LINK_)
  set(LINK_ ${LINK_}_LINKER_FLAGS)

  find_key_value(${LINK_} ${THRUST_MODE} flags_)
  LIST(APPEND ${LINKER_FLAGS_} ${flags_})

  find_key_value(${LINK_} WORKAROUNDS flags_)
  LIST(APPEND ${LINKER_FLAGS_} ${flags_})
  
  find_key_value(${LINK_} ${HOST_BACKEND} flags_)
  LIST(APPEND ${LINKER_FLAGS_} ${flags_})
  
  find_key_value(${LINK_} ${DEVICE_BACKEND} flags_)
  LIST(APPEND ${LINKER_FLAGS_} ${flags_})
endmacro()

macro(thrust_add_executable TARGET)
  if ((NOT "${DEVICE_BACKEND}" STREQUAL "CUDA") AND (NOT "${DEVICE_BACKEND}" STREQUAL "CUDA_BULK")) # AND "${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    set_source_files_properties(${ARGN} PROPERTIES LANGUAGE CXX)
    add_executable(${TARGET} ${ARGN})
    set_target_properties(${TARGET} PROPERTIES LINKER_LANGUAGE CXX)
    set_target_properties(${TARGET} PROPERTIES COMPILE_FLAGS "-x c++")
  else()
    cuda_add_executable(${TARGET} ${ARGN})
  endif()
endmacro()

#macro(thrust_include_directories TARGET)
#  if (NOT "${DEVICE_BACKEND}" STREQUAL "CUDA") # AND "${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
#    target_include_directories(${TARGET} PRIVATE ${ARGN})
#  else()
#    cuda_include_directories(${ARGN})
#  endif()
#endmacro()

# Find backends

find_package(CUDA)
find_package(OpenMP)

# Set flags

set_thrust_flags(THRUST_FLAGS)
set_cc_compiler_flags(CC_FLAGS)
set_nv_compiler_flags(NV_FLAGS)
set_linker_flags(LINKER_FLAGS)

# Debug output
# message("THRUST_FLAGS= ${THRUST_FLAGS}")
# message("CC_FLAGS= ${CC_FLAGS}")
# message("NV_FLAGS= ${NV_FLAGS}")
# message("LINKER_FLAGS= ${LINKER_FLAGS}")

string (REPLACE ";" " " CC_FLAGS_STR "${CC_FLAGS} ${THRUST_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CC_FLAGS_STR}")
set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} ${NV_FLAGS})
string (REPLACE ";" " " LINKER_FLAGS_STR "${LINKER_FLAGS}")
set(CMAKE_EXEC_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LINKER_FLAGS_STR}")

# Enable separable compilation when building with CUDA Dynamic Parallelism
set(CUDA_SEPARABLE_COMPILATION ${CUDA_CDP})
# and find "cudadevrt" library for linking, otherwise <<<,>>> will fail to build
if (${CUDA_CDP})
  cuda_find_library_local_first(CUDADEVRT_LIBRARY cudadevrt "\"cudadevrt\" library")
  if ("${CUDADEVRT_LIBRARY}" STREQUAL "CUDADEVRT_LIBRARY-NOTFOUND")
    message(FATAL_ERROR "\"cudadevrt\" library not found. Consider disabling CUDA_CDP.")
  endif()
  link_libraries(${CUDADEVRT_LIBRARY})
endif()


include_directories(${CMAKE_SOURCE_DIR})
cuda_include_directories(${CMAKE_SOURCE_DIR})

# Add targets

# thrust target
install(DIRECTORY ${CMAKE_SOURCE_DIR}/thrust/ DESTINATION thrust COMPONENT thrust)
install(FILES ${CMAKE_SOURCE_DIR}/CHANGELOG DESTINATION thrust COMPONENT thrust)
add_custom_target(install-thrust
  COMMAND
      "${CMAKE_COMMAND}" -DCMAKE_INSTALL_COMPONENT=thrust
      -P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
)

# add examples, testing and performance testing targets
add_subdirectory(examples)
add_subdirectory(testing)
add_subdirectory(performance)

### make zip acrhive

set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
set(CPACK_GENERATOR "ZIP")
set(CPACK_PACKAGE_VERSION "${Thrust_VERSION_MAJOR}.${Thrust_VERSION_MINOR}.${Thrust_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${Thrust_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${Thrust_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${Thrust_VERSION_PATCH}")
set(CPACK_COMPONENTS_ALL thrust examples)
set(CPACK_ZIP_USE_DISPLAY_NAME_IN_FILENAME ON)
set(CPACK_PACKAGE_FILE_NAME "Thrust-${CPACK_PACKAGE_VERSION}")
include(CPack)
cpack_add_component(thrust DISPLAY_NAME "headers")
cpack_add_component(examples DISPLAY_NAME "examples")

=== Makefile ===
# Copyright 1993-2010 NVIDIA Corporation.  All rights reserved.
#
# NOTICE TO USER:
#
# This source code is subject to NVIDIA ownership rights under U.S. and
# international Copyright laws.
#
# This software and the information contained herein is being provided
# under the terms and conditions of a Source Code License Agreement.
#
# NVIDIA MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS SOURCE
# CODE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR
# IMPLIED WARRANTY OF ANY KIND.  NVIDIA DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS SOURCE CODE, INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY, NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
# IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL,
# OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
# OF USE, DATA OR PROFITS,  WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
# OR OTHER TORTIOUS ACTION,  ARISING OUT OF OR IN CONNECTION WITH THE USE
# OR PERFORMANCE OF THIS SOURCE CODE.
#
# U.S. Government End Users.   This source code is a "commercial item" as
# that term is defined at  48 C.F.R. 2.101 (OCT 1995), consisting  of
# "commercial computer  software"  and "commercial computer software
# documentation" as such terms are  used in 48 C.F.R. 12.212 (SEPT 1995)
# and is provided to the U.S. Government only as a commercial end item.
# Consistent with 48 C.F.R.12.212 and 48 C.F.R. 227.7202-1 through
# 227.7202-4 (JUNE 1995), all U.S. Government End Users acquire the
# source code with only those rights set forth herein.

# Makefile for building Thrust unit test driver

# Force C++11 mode. NVCC will ignore it if the host compiler doesn't support it.
#export CXX_STD = c++11

export VERBOSE = 1

ifndef PROFILE
  ifdef VULCAN_TOOLKIT_BASE
    include $(VULCAN_TOOLKIT_BASE)/build/getprofile.mk
    include $(VULCAN_TOOLKIT_BASE)/build/config/$(PROFILE).mk
  else
    include ../build/getprofile.mk
    include ../build/config/$(PROFILE).mk
  endif
endif

SOLNDIR := .

ifdef VULCAN_TOOLKIT_BASE
  include $(VULCAN_TOOLKIT_BASE)/build/config/DetectOS.mk
else
  include ../build/config/DetectOS.mk
endif

ifeq ($(OS),win32)
  export I_AM_SLOPPY := 1
endif

TMP_DIR      := built
TMP_PREFIX   := $(ROOTDIR)
TMP_ARCH     := $(ARCH)_$(PROFILE)_agnostic
THRUST_MKDIR := $(TMP_PREFIX)/$(TMP_DIR)/$(TMP_ARCH)/thrust/mk
THRUST_DIR   := $(ROOTDIR)/thrust

res:=$(shell $(PYTHON) ./generate_mk.py $(THRUST_MKDIR) $(THRUST_DIR))

# Use these environment variables to control what gets built:
#
#   TEST_ALL
#   TEST_UNITTESTS
#   TEST_EXAMPLES
#   TEST_BENCH
#   TEST_OTHER

ifneq ($(TEST_ALL),)
  override TEST_UNITTESTS := 1
  override TEST_EXAMPLES := 1
  override TEST_BENCH := 1
  override TEST_OTHER := 1
endif

ifeq ($(TEST_UNITTESTS)$(TEST_EXAMPLES)$(TEST_BENCH)$(TEST_OTHER),)
  override TEST_UNITTESTS := 1
  override TEST_EXAMPLES := 1
  override TEST_BENCH := 1
  override TEST_OTHER := 1
endif

ifneq ($(TEST_OTHER),)
  PROJECTS += internal/build/warningstester
endif

ifneq ($(TEST_BENCH),)
  PROJECTS += internal/benchmark/bench
endif

ifneq ($(TEST_UNITTESTS),)
  # copy existing projects
  PROJECTS_COPY := $(PROJECTS)

  # empty PROJECTS
  PROJECTS :=

  # populate PROJECTS with unit tests.
  include $(THRUST_MKDIR)/testing.mk

  # Once PROJECTS is populated with unit tests, re-add the previous projects.
  PROJECTS += $(PROJECTS_COPY)
endif

ifneq ($(TEST_EXAMPLES),)
  # Copy existing projects.
  PROJECTS_COPY := $(PROJECTS)

  # Empty PROJECTS.
  PROJECTS :=

	# Populate PROJECTS with examples.
  include $(THRUST_MKDIR)/examples.mk

  # Once PROJECTS is populated with examples, re-add the previous projects.
  PROJECTS += $(PROJECTS_COPY)
endif

ifdef VULCAN_TOOLKIT_BASE
  include $(VULCAN_TOOLKIT_BASE)/build/common.mk
else
  include ../build/common.mk
endif

# Print host compiler version.

VERSION_FLAG :=
ifeq ($(OS),$(filter $(OS),Linux Darwin))
	ifdef USEPGCXX        # PGI
		VERSION_FLAG := -V
	else
		ifdef USEXLC        # XLC
			VERSION_FLAG := -qversion
		else                # GCC, ICC or Clang AKA the sane ones.
			VERSION_FLAG := --version
		endif
	endif
else ifeq ($(OS),win32) # MSVC
	# cl.exe run without any options will print its version info and exit.
	VERSION_FLAG :=
endif

CCBIN_ENVIRONMENT :=
ifeq ($(OS), QNX)
	# QNX's GCC complains if QNX_HOST and QNX_TARGET aren't defined in the
	# environment.
	CCBIN_ENVIRONMENT := QNX_HOST=$(QNX_HOST) QNX_TARGET=$(QNX_TARGET)
endif

$(info #### CCBIN         : $(CCBIN))
$(info #### CCBIN VERSION : $(shell $(CCBIN_ENVIRONMENT) $(CCBIN) $(VERSION_FLAG)))
$(info #### CXX_STD       : $(CXX_STD))

ifeq ($(OS), win32)
  CREATE_DVS_PACKAGE = $(ZIP) -r built/CUDA-thrust-package.zip bin thrust/internal/test thrust/internal/scripts thrust/internal/benchmark thrust/*.trs $(DVS_COMMON_TEST_PACKAGE_FILES)
  APPEND_HEADERS_DVS_PACKAGE = $(ZIP) -rg built/CUDA-thrust-package.zip thrust -9 -i *.h
  APPEND_INL_DVS_PACKAGE = $(ZIP) -rg built/CUDA-thrust-package.zip thrust -9 -i *.inl
  APPEND_CUH_DVS_PACKAGE = $(ZIP) -rg built/CUDA-thrust-package.zip thrust -9 -i *.cuh
  MAKE_DVS_PACKAGE = $(CREATE_DVS_PACKAGE) && $(APPEND_HEADERS_DVS_PACKAGE) && $(APPEND_INL_DVS_PACKAGE) && $(APPEND_CUH_DVS_PACKAGE)
else
  CREATE_DVS_PACKAGE = tar -cv -f built/CUDA-thrust-package.tar bin thrust/internal/test thrust/internal/scripts thrust/internal/benchmark thrust/*.trs $(DVS_COMMON_TEST_PACKAGE_FILES)
  APPEND_HEADERS_DVS_PACKAGE = find thrust -name "*.h" | xargs tar rvf built/CUDA-thrust-package.tar
  APPEND_INL_DVS_PACKAGE = find thrust -name "*.inl" | xargs tar rvf built/CUDA-thrust-package.tar
  APPEND_CUH_DVS_PACKAGE = find thrust -name "*.cuh" | xargs tar rvf built/CUDA-thrust-package.tar
  COMPRESS_DVS_PACKAGE = bzip2 built/CUDA-thrust-package.tar
  MAKE_DVS_PACKAGE = $(CREATE_DVS_PACKAGE) && $(APPEND_HEADERS_DVS_PACKAGE) && $(APPEND_INL_DVS_PACKAGE) && $(APPEND_CUH_DVS_PACKAGE) && $(COMPRESS_DVS_PACKAGE)
endif

DVS_OPTIONS :=

ifneq ($(TARGET_ARCH),$(HOST_ARCH))
  DVS_OPTIONS += TARGET_ARCH=$(TARGET_ARCH)
endif
ifeq ($(TARGET_ARCH),ARMv7)
  DVS_OPTIONS += ABITYPE=$(ABITYPE)
endif

THRUST_DVS_BUILD = release

pack:
	cd .. && $(MAKE_DVS_PACKAGE)

dvs:
	$(MAKE) $(DVS_OPTIONS) -s -C ../cuda $(THRUST_DVS_BUILD)
	$(MAKE) $(DVS_OPTIONS) $(THRUST_DVS_BUILD) THRUST_DVS=1
	cd .. && $(MAKE_DVS_PACKAGE)

# XXX Deprecated, remove.
dvs_nightly: dvs

dvs_release:
	$(MAKE) dvs THRUST_DVS_BUILD=release

dvs_debug:
	$(MAKE) dvs THRUST_DVS_BUILD=debug

include $(THRUST_MKDIR)/dependencies.mk

=== SConstruct ===
"""Exports a SCons construction environment 'env' with configuration common to all build projects"""
EnsureSConsVersion(1,2)

import os
import platform
import glob
import itertools
import subprocess


def RecursiveGlob(env, pattern, directory = Dir('.'), exclude = '\B'):
  """Recursively globs a directory and its children, returning a list of sources.
  Allows exclusion of directories given a regular expression.
  """
  directory = Dir(directory)

  result = directory.glob(pattern)

  for n in directory.glob('*'):
    # only recurse into directories which aren't in the blacklist
    import re
    if isinstance(n,type(directory)) and not re.match(exclude, directory.rel_path(n)):
      result.extend(RecursiveGlob(env, pattern, n, exclude))
  return result


# map features to the list of compiler switches implementing them
gnu_compiler_flags = {
  'warn_all'           : ['-Wextra', '-Wall'],
  'warnings_as_errors' : ['-Werror'],
  'release'            : ['-O2'],
  'debug'              : ['-g'],
  'exception_handling' : [],
  'cpp'                : [],
  'omp'                : ['-fopenmp'],
  'tbb'                : [],
  'cuda'               : [],
  'workarounds'        : [],
  'c++03'              : [],
  'c++11'              : ['-std=c++11']
}

clang_compiler_flags = {
  'warn_all'           : ['-Wextra', '-Wall'],
  'warnings_as_errors' : ['-Werror'],
  'release'            : ['-O2'],
  'debug'              : ['-g'],
  'exception_handling' : [],
  'cpp'                : [],
  'omp'                : ['-fopenmp'],
  'tbb'                : [],
  'cuda'               : [],
  'workarounds'        : [],
  'c++03'              : [],
  'c++11'              : ['-std=c++11']
}

msvc_compiler_flags = {
  'warn_all'           : ['/Wall'],
  'warnings_as_errors' : ['/WX'],
  'release'            : ['/Ox'],
  'debug'              : ['/Zi', '-D_DEBUG', '/MTd'],
  'exception_handling' : ['/EHsc'],
  'cpp'                : [],
  'omp'                : ['/openmp'],
  'tbb'                : [],
  'cuda'               : [],

  # avoid min/max problems due to windows.h
  # suppress warnings due to "decorated name length exceeded"
  'workarounds'        : ['/DNOMINMAX', '/wd4503'],
  'c++03'              : [],
  'c++11'              : []
}

compiler_to_flags = {
  'g++' : gnu_compiler_flags,
  'cl'  : msvc_compiler_flags,
  'clang++'  : clang_compiler_flags
}

gnu_linker_flags = {
  'debug'       : [],
  'release'     : [],
  'workarounds' : []
}

nv_linker_flags = gnu_linker_flags

clang_linker_flags = {
  'debug'       : [],
  'release'     : [],
  'workarounds' : ['-stdlib=libstdc++']
}

msvc_linker_flags = {
  'debug'       : ['/debug'],
  'release'     : [],
  'workarounds' : ['/nologo']
}

linker_to_flags = {
  'gcc'  : gnu_linker_flags,
  'link' : msvc_linker_flags,
  'nvcc' : nv_linker_flags,
  'clang++'  : clang_linker_flags
}

def cuda_installation(env):
  """Returns the details of CUDA's installation
  returns (bin_path,lib_path,inc_path,library_name)
  """

  cuda_path = env['cuda_path']
  bin_path = cuda_path + '/bin'
  lib_path = cuda_path + '/lib'
  inc_path = cuda_path + '/include'
   
  # fix up the name of the lib directory on 64b platforms
  if platform.machine()[-2:] == '64':
    if os.name == 'posix' and platform.system() != 'Darwin':
      lib_path += '64'
    elif os.name == 'nt':
      lib_path += '/x64'

  # override with environment variables
  if 'CUDA_BIN_PATH' in os.environ:
    bin_path = os.path.abspath(os.environ['CUDA_BIN_PATH'])
  if 'CUDA_LIB_PATH' in os.environ:
    lib_path = os.path.abspath(os.environ['CUDA_LIB_PATH'])
  if 'CUDA_INC_PATH' in os.environ:
    inc_path = os.path.abspath(os.environ['CUDA_INC_PATH'])

  return (bin_path,lib_path,inc_path,'cudart',cuda_path)


def omp_installation(CXX):
  """Returns the details of OpenMP's installation
  returns (bin_path,lib_path,inc_path,library_name)
  """

  bin_path = ''
  lib_path = ''
  inc_path = ''

  # the name of the library is compiler-dependent
  library_name = ''
  if CXX == 'g++':
    library_name = 'gomp'
  elif CXX == 'cl':
    library_name = 'VCOMP'
  elif CXX == 'clang++':
    raise NotImplementedError, "OpenMP not supported together with clang"
  else:
    raise ValueError, "Unknown compiler. What is the name of the OpenMP library?"

  return (bin_path,lib_path,inc_path,library_name)


def tbb_installation(env):
  """Returns the details of TBB's installation
  returns (bin_path,lib_path,inc_path,library_name)
  """

  # determine defaults
  if os.name == 'nt':
    try:
      # we assume that TBBROOT exists in the environment
      root = env['ENV']['TBBROOT']

      # choose bitness
      bitness = 'ia32'
      if platform.machine()[-2:] == '64':
        bitness = 'intel64'

      # choose msvc version
      msvc_version = 'vc' + str(int(float(env['MSVC_VERSION'])))
      
      # assemble paths
      bin_path = os.path.join(root, 'bin', bitness, msvc_version)
      lib_path = os.path.join(root, 'lib', bitness, msvc_version)
      inc_path = os.path.join(root, 'include')
        
    except:
      raise ValueError, 'Where is TBB installed?'
  else:
    bin_path = ''
    lib_path = ''
    inc_path = ''

  return (bin_path,lib_path,inc_path,'tbb')


def inc_paths(env, host_backend, device_backend):
  """Returns a list of include paths needed by the compiler"""
  result = []
  thrust_inc_path = Dir('.')

  # note that the thrust path comes before the cuda path, which
  # may itself contain a different version of thrust
  result.append(thrust_inc_path)
  
  if host_backend == 'cuda' or device_backend == 'cuda':
    cuda_inc_path = cuda_installation(env)[2]
    result.append(cuda_inc_path)

  if host_backend == 'tbb' or device_backend == 'tbb':
    tbb_inc_path  = tbb_installation(env)[2]
    result.append(tbb_inc_path)

  return result
  

def lib_paths(env, host_backend, device_backend):
  """Returns a list of lib paths needed by the linker"""
  result = []

  if host_backend == 'cuda' or device_backend == 'cuda':
    cuda_lib_path = cuda_installation(env)[1]
    result.append(cuda_lib_path)

  if host_backend == 'tbb' or device_backend == 'tbb':
    tbb_lib_path  = tbb_installation(env)[1]
    result.append(tbb_lib_path)

  return result


def libs(env, CCX, host_backend, device_backend):
  """Returns a list of libraries to link against"""
  result = []

  # when compiling with g++, link against the standard library
  # we don't have to do this with cl
  if CCX == 'g++':
    result.append('stdc++')
    result.append('m')

  # link against backend-specific runtimes
  if host_backend == 'cuda' or device_backend == 'cuda':
    result.append(cuda_installation(env)[3])

    # XXX clean this up
    if env['cdp']:
      result.append('cudadevrt')

  if host_backend == 'omp' or device_backend == 'omp':
    result.append(omp_installation(CCX)[3])

  if host_backend == 'tbb' or device_backend == 'tbb':
    result.append(tbb_installation(env)[3])

  return result


def linker_flags(LINK, mode, platform, device_backend, arch):
  """Returns a list of command line flags needed by the linker"""
  result = []

  flags = linker_to_flags[LINK]

  # debug/release
  result.extend(flags[mode])

  # unconditional workarounds
  result.extend(flags['workarounds'])

  return result

  
def macros(mode, host_backend, device_backend):
  """Returns a list of preprocessor macros needed by the compiler"""
  result = []

  # backend defines
  result.append('-DTHRUST_HOST_SYSTEM=THRUST_HOST_SYSTEM_' + host_backend.upper())
  result.append('-DTHRUST_DEVICE_SYSTEM=THRUST_DEVICE_SYSTEM_' + device_backend.upper())

  if mode == 'debug':
    # turn on thrust debug mode
    result.append('-DTHRUST_DEBUG')

  return result


def cc_compiler_flags(CXX, mode, platform, host_backend, device_backend, warn_all, warnings_as_errors, cpp_standard):
  """Returns a list of command line flags needed by the c or c++ compiler"""
  # start with all platform-independent preprocessor macros
  result = macros(mode, host_backend, device_backend)

  flags = compiler_to_flags[CXX]

  # continue with unconditional flags

  # exception handling
  result.extend(flags['exception_handling'])

  # finish with conditional flags

  # debug/release
  result.extend(flags[mode])

  # enable host_backend code generation
  result.extend(flags[host_backend])

  # enable device_backend code generation
  result.extend(flags[device_backend])

  # Wall
  if warn_all:
    result.extend(flags['warn_all'])

  # Werror 
  if warnings_as_errors:
    result.extend(flags['warnings_as_errors'])

  # workarounds
  result.extend(flags['workarounds'])

  # c++ standard
  result.extend(flags[cpp_standard])

  return result


def nv_compiler_flags(mode, device_backend, arch, cdp):
  """Returns a list of command line flags specific to nvcc"""
  result = []
  for machine_arch in arch:
    # transform arch_XX to compute_XX
    virtual_arch = machine_arch.replace('sm','compute')
    # the weird -gencode flag is formatted like this:
    # -gencode=arch=compute_10,code=\"sm_20,compute_20\"
    result.append('-gencode=arch={0},\\"code={1},{2}\\"'.format(virtual_arch, machine_arch, virtual_arch))

  if mode == 'debug':
    # turn on debug mode
    # XXX make this work when we've debugged nvcc -G
    #result.append('-G')
    pass
  if device_backend != 'cuda':
    result.append("--x=c++")
  if cdp != False:
    result.append("-rdc=true")

  if device_backend == 'cuda' and master_env['PLATFORM'] == 'darwin':
    (release, versioninfo, machine) = platform.mac_ver()
    if(release[0:5] == '10.8.'):
      result.append('-ccbin')
      result.append(master_env.subst('$CXX'))
  
  return result

def clang_compiler_flags(mode, arch):
  """Returns a list of command line flags specific to clang"""
  result = []
  for machine_arch in arch:
    result.append('--cuda-gpu-arch={0}'.format(machine_arch))
  return result

def command_line_variables():
  # allow the user discretion to select the MSVC version
  vars = Variables()
  if os.name == 'nt':
    vars.Add(EnumVariable('MSVC_VERSION', 'MS Visual C++ version', None, allowed_values=('8.0', '9.0', '10.0', '11.0', '12.0', '13.0')))
  
  # add a variable to handle the host backend
  vars.Add(ListVariable('host_backend', 'The host backend to target', 'cpp',
                        ['cpp', 'omp', 'tbb']))
  
  # add a variable to handle the device backend
  vars.Add(ListVariable('device_backend', 'The parallel device backend to target', 'cuda',
                        ['cuda', 'omp', 'tbb', 'cpp']))
  
  # add a variable to handle release/debug mode
  vars.Add(EnumVariable('mode', 'Release versus debug mode', 'release',
                        allowed_values = ('release', 'debug')))
  
  # allow the option to send sm_1x to nvcc even though nvcc may not support it
  vars.Add(ListVariable('arch', 'Compute capability code generation', 'sm_30',
                         ['sm_30', 'sm_32', 'sm_35', 'sm_37',
                          'sm_50', 'sm_52', 'sm_60', 'sm_61']))

  # add a variable to handle CUDA dynamic parallelism
  vars.Add(BoolVariable('cdp', 'Enable CUDA dynamic parallelism', False))
  
  # add a variable to handle warnings
  # only enable Wall by default on compilers other than cl
  vars.Add(BoolVariable('Wall', 'Enable all compilation warnings', os.name != 'nt'))
  
  # add a variable to treat warnings as errors
  vars.Add(BoolVariable('Werror', 'Treat warnings as errors', os.name != 'nt'))
  
  # add a variable to switch between C++ standards
  vars.Add(EnumVariable('std', 'C++ standard', 'c++03',
                        allowed_values = ('c++03', 'c++11')))

  # add a variable to select C++ standard
  vars.Add(EnumVariable('std', 'C++ standard', 'c++03',
                        allowed_values = ('c++03', 'c++11')))

  vars.Add(EnumVariable('cuda_compiler', 'CUDA compiler', 'nvcc',
                        allowed_values = ('nvcc', 'clang')))

  # determine defaults
  if 'CUDA_PATH' in os.environ:

=== examples/CMakeLists.txt ===
# message(STATUS "Adding \"examples\"")

#aux_source_directory("testing" sources)
FILE(GLOB SOURCES_CU  *.cu)
FILE(GLOB SOURCES_CPP *.cpp)
set(SOURCES ${SOURCES_CU})

list(LENGTH SOURCES index)
message(STATUS "Found ${index} examples")

set(targets "")
foreach (src ${SOURCES})
  get_filename_component(exec_name ${src} NAME_WE)
  set(target example-${exec_name})
  thrust_add_executable(${target} ${src})
  set_target_properties(${target} PROPERTIES OUTPUT_NAME ${exec_name})
  install(TARGETS ${target} DESTINATION "examples/${HOST_BACKEND}_host_${DEVICE_BACKEND}_device_${THRUST_MODE}" OPTIONAL COMPONENT examples-bin)
  list(APPEND targets ${target})
endforeach()

add_subdirectory(cuda)
add_subdirectory(omp)
add_subdirectory(cpp_integration)

add_custom_target(examples-bin DEPENDS ${targets})
add_custom_target(install-examples-bin
  COMMAND 
      "${CMAKE_COMMAND}" -DCMAKE_INSTALL_COMPONENT=examples-bin
      -P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
)

install(FILES ${SOURCES} DESTINATION "examples" COMPONENT examples)

=== performance/CMakeLists.txt ===
# message(STATUS "Adding \"testing\"")

FILE(GLOB SOURCES_TEST *.test)

list(LENGTH SOURCES_TEST index)
message(STATUS "Found ${index} performance tests")


find_package(PythonInterp)
if (NOT ${PYTHONINTERP_FOUND})
  message("** Python is not found. Skipping performance tests")
  return()
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)
cuda_include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
cuda_include_directories(${CMAKE_SOURCE_DIR}/testing)
include_directories(${CMAKE_SOURCE_DIR}/testing)

set(compile_source "${CMAKE_CURRENT_BINARY_DIR}/compile_source.py")
FILE(WRITE ${compile_source}
  "import sys\n"
  "sys.path.append(\"${CMAKE_CURRENT_SOURCE_DIR}\")\n"
  "from build.perftest import compile_test\n"
  "compile_test(str(sys.argv[1]),str(sys.argv[2]))\n"
  )
set(targets "")
set(perf_sources "")
foreach(src ${SOURCES_TEST})
  get_filename_component(exec_name ${src} NAME_WE)
  set(target perf-${exec_name})
  set(dst ${CMAKE_CURRENT_BINARY_DIR}/${exec_name}.cu)
  add_custom_command(
    OUTPUT ${dst}
    DEPENDS ${src}
    COMMAND "${PYTHON_EXECUTABLE}" 
    ARGS ${compile_source}$ "" ${src} "" ${dst}$  "" ${dst}
    COMMENT "Generate perforfmance test \"${dst}\" from \"${src}\" "
    )
  set(cuda_src ${dst})
  thrust_add_executable(${target} ${cuda_src})
  set_target_properties(${target} PROPERTIES OUTPUT_NAME ${exec_name})
  install(TARGETS ${target} DESTINATION "performance/${HOST_BACKEND}_host_${DEVICE_BACKEND}_device_${THRUST_MODE}" OPTIONAL COMPONENT performance-bin)
  list(APPEND targets ${target})
  list(APPEND perf_sources ${cuda_src})
endforeach()

add_custom_target(performance-bin DEPENDS ${targets})
add_custom_target(install-performance-bin
  COMMAND 
      "${CMAKE_COMMAND}" -DCMAKE_INSTALL_COMPONENT=performance-bin
      -P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
)

# install(FILES ${perf_sources} DESTINATION "performance" COMPONENT performance)

=== testing/CMakeLists.txt ===
set(DRIVER "${CMAKE_CURRENT_SOURCE_DIR}/testframework.cpp")

FILE(GLOB SOURCES_CU  *.cu)
FILE(GLOB SOURCES_CPP *.cpp)
set(SOURCES ${SOURCES_CU} ${SOURCES_CPP})

list(FIND SOURCES ${DRIVER} index)
if (${index} EQUAL -1)
  MESSAGE(FATAL_ERROR "${DRIVER} was not found in source list. Something went wrong")
endif()

list(REMOVE_AT SOURCES ${index} SOURCES)

list(LENGTH SOURCES index)
message(STATUS "Found ${index} tests in testing")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
cuda_include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(backend)

cuda_add_library(test_driver ${DRIVER} STATIC EXCLUDE_FROM_ALL)

set(targets "")
foreach(src ${SOURCES})
  get_filename_component(exec_name ${src} NAME_WE)
  set(target testing-${exec_name})
  thrust_add_executable(${target} ${src})
  target_link_libraries(${target} test_driver)
  set_target_properties(${target} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_test(NAME ${target} COMMAND ${target})
  list(APPEND targets ${target})
endforeach()

string(TOLOWER ${DEVICE_BACKEND} backend)
set(targets-backend "")
foreach(src ${SOURCES_BACKEND})
  get_filename_component(exec_name ${src} NAME_WE)
  set(target testing-${backend}-${exec_name})
  thrust_add_executable(${target} ${src})
  target_link_libraries(${target} test_driver)
  set_target_properties(${target} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_test(NAME ${target} COMMAND ${target})
  list(APPEND targets-backend ${target})
endforeach()

add_custom_target(testing DEPENDS ${targets} ${targets-backend})
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
add_dependencies(check testing)

=== examples/cpp_integration/CMakeLists.txt ===
FILE(GLOB SOURCES_CU  *.cu)
FILE(GLOB SOURCES_CPP *.cpp)
FILE(GLOB SOURCES_H *.h)
set(SOURCES_BACKEND ${SOURCES_CU} ${SOURCES_CPP} ${SOURCES_H})
list(APPEND SOURCES_BACKEND "README")

install(FILES ${SOURCES_BACKEND} DESTINATION "examples/cpp_integration" COMPONENT examples)

if (NOT "x${DEVICE_BACKEND}" STREQUAL "xCUDA")
  return()
endif()

list(LENGTH SOURCES_BACKEND index)
message(STATUS "Found ${index} examples/cpp_integration")

set(targets_backend "")
set(exec_name "cpp_integration")
set(target example-${exec_name})
thrust_add_executable(${target} ${SOURCES_BACKEND})
set_target_properties(${target} PROPERTIES OUTPUT_NAME ${exec_name})
install(TARGETS ${target} DESTINATION "examples/cpp_integration/${HOST_BACKEND}_host_${DEVICE_BACKEND}_device_${THRUST_MODE}" OPTIONAL COMPONENT examples-bin)
list(APPEND targets_backend ${target})

set(targets ${targets} ${targets_backend} PARENT_SCOPE)

=== examples/cuda/CMakeLists.txt ===

FILE(GLOB SOURCES_CU  *.cu)
FILE(GLOB SOURCES_CPP *.cpp)
FILE(GLOB SOURCES_H *.h)
set(SOURCES_BACKEND ${SOURCES_CU} ${SOURCES_CPP} ${SOURCES_H})

install(FILES ${SOURCES_BACKEND} DESTINATION "examples/cuda" COMPONENT examples)

if (NOT "x${DEVICE_BACKEND}" STREQUAL "xCUDA")
  return()
endif()

list(LENGTH SOURCES_BACKEND index)
message(STATUS "Found ${index} examples/cuda")

set(targets_backend "")
foreach (src ${SOURCES_BACKEND})
  get_filename_component(exec_name ${src} NAME_WE)
  set(target example-${exec_name})
  thrust_add_executable(${target} ${src})
  set_target_properties(${target} PROPERTIES OUTPUT_NAME ${exec_name})
  install(TARGETS ${target} DESTINATION "examples/cuda/${HOST_BACKEND}_host_${DEVICE_BACKEND}_device_${THRUST_MODE}" OPTIONAL COMPONENT examples-bin)
  list(APPEND targets_backend ${target})
endforeach()

set(targets ${targets} ${targets_backend} PARENT_SCOPE)

=== examples/omp/CMakeLists.txt ===
FILE(GLOB SOURCES_CU  *.cu)
FILE(GLOB SOURCES_CPP *.cpp)
set(SOURCES_BACKEND ${SOURCES_CU})

install(FILES ${SOURCES_BACKEND} DESTINATION "examples/omp" COMPONENT examples)

if (NOT "x${DEVICE_BACKEND}" STREQUAL "xOMP")
  return()
endif()

=== testing/backend/CMakeLists.txt ===

FILE(GLOB SOURCES_CU  *.cu)
FILE(GLOB SOURCES_CPP *.cpp)
set(SOURCES_BACKEND ${SOURCES_CU} ${SOURCES_CPP})

string(TOLOWER ${DEVICE_BACKEND} backend)
add_subdirectory(${backend})

#set(SOURCES ${SOURCES} ${SOURCES_BACKEND} PARENT_SCOPE)
set(SOURCES_BACKEND ${SOURCES_BACKEND} PARENT_SCOPE)

list(LENGTH SOURCES_BACKEND index)
message(STATUS "Found ${index} tests in backend")

set(DRIVER ${DRIVER} PARENT_SCOPE)

=== testing/backend/cuda/CMakeLists.txt ===
set(DRIVER_BACKEND "${CMAKE_CURRENT_SOURCE_DIR}/testframework.cu")
FILE(GLOB SOURCES_CU  *.cu)
FILE(GLOB SOURCES_CPP *.cpp)

set(SOURCES_BACKEND ${SOURCES_BACKEND} ${SOURCES_CU} ${SOURCES_CPP} PARENT_SCOPE)
set(DRIVER ${DRIVER} ${DRIVER_BACKEND} PARENT_SCOPE)

=== testing/backend/omp/CMakeLists.txt ===
set(DRIVER_BACKEND "")
FILE(GLOB SOURCES_CU  *.cu)
FILE(GLOB SOURCES_CPP *.cpp)

set(SOURCES_BACKEND ${SOURCES_BACKEND} ${SOURCES_CU} ${SOURCES_CPP} PARENT_SCOPE)
set(DRIVER ${DRIVER} ${DRIVER_BACKEND} PARENT_SCOPE)

## libthrust 1.5.0

=== debian/changelog ===
libthrust (1.5.0-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright:
    - Update to dep5.mdwn?revision=202.
    - Update copyright entries for added/moved files.

 -- Andreas Beckmann <debian@abeckmann.de>  Fri, 02 Dec 2011 01:48:24 +0100

=== debian/control ===
Source: libthrust
Section: contrib/libdevel
Priority: extra
Maintainer: Andreas Beckmann <debian@abeckmann.de>
Build-Depends: debhelper (>= 8)
Standards-Version: 3.9.2
Homepage: http://thrust.googlecode.com/
Vcs-Svn: svn://svn.debian.org/pkg-nvidia/packages/libthrust/trunk
Vcs-Browser: http://svn.debian.org/wsvn/pkg-nvidia/packages/libthrust/
DM-Upload-Allowed: yes

Package: libthrust-dev
Architecture: all
Depends: ${misc:Depends}
Recommends: nvidia-cuda-toolkit
Description: Thrust - C++ template library for CUDA
 Thrust is a CUDA library of parallel algorithms with an interface
 resembling the C++ Standard Template Library (STL). Thrust provides a
 flexible high-level interface for GPU programming by providing a rich
 collection of data parallel primitives such as scan, sort, and reduce.
 It then automatically selects an efficient implementation without
 requiring source modifications.
 .
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.

=== debian/watch ===
version=3

http://googlecode.debian.net/p/thrust/thrust-(\d+.*).zip

## libthrust 1.5.1

=== debian/changelog ===
libthrust (1.5.1-1) unstable; urgency=low

  * New upstream release.
  * Set Maintainer to Debian NVIDIA Maintainers and move myself to Uploaders.

 -- Andreas Beckmann <debian@abeckmann.de>  Fri, 17 Feb 2012 12:05:55 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,9 @@
 Source: libthrust
 Section: contrib/libdevel
 Priority: extra
-Maintainer: Andreas Beckmann <debian@abeckmann.de>
+Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
+Uploaders:
+ Andreas Beckmann <debian@abeckmann.de>,
 Build-Depends: debhelper (>= 8)
 Standards-Version: 3.9.2
 Homepage: http://thrust.googlecode.com/

## libthrust 1.6.0

=== debian/changelog ===
libthrust (1.6.0-1) unstable; urgency=low

  [ Andreas Beckmann ]
  * New upstream release.  (Closes: #671939)
  * New upstream hosting: http://thrust.github.com
  * Update watch file.
  * Move libthrust-dev from contrib to main as it gained support for OpenMP
    and TBB in addition to CUDA.  Update the description accordingly and
    lower the Recommends: nvidia-cuda-toolkit to a Suggests.
    (Closes: #671778)
  * Use the final copyright-format 1.0 URL.
  * Update to Standards-Version: 3.9.3.

  [ Mathieu Malaterre ]
  * Add get-orig-source in d/rules

 -- Andreas Beckmann <debian@abeckmann.de>  Wed, 09 May 2012 14:56:27 +0200

=== debian/control ===
Source: libthrust
Section: libdevel
Priority: extra
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <debian@abeckmann.de>,
Build-Depends: debhelper (>= 8)
Standards-Version: 3.9.3
Homepage: http://thrust.github.com/
Vcs-Svn: svn://svn.debian.org/pkg-nvidia/packages/libthrust/trunk
Vcs-Browser: http://svn.debian.org/wsvn/pkg-nvidia/packages/libthrust/
DM-Upload-Allowed: yes

Package: libthrust-dev
Architecture: all
Depends: ${misc:Depends}
Suggests: nvidia-cuda-toolkit
Description: Thrust - Parallel Algorithms Library
 Thrust is a parallel algorithms library which resembles the C++ Standard
 Template Library (STL). Thrust's high-level interface greatly enhances
 programmer productivity while enabling performance portability between GPUs
 and multicore CPUs. Interoperability with established technologies (such as
 CUDA, TBB, and OpenMP) facilitates integration with existing software.

=== debian/watch ===
version=3

https://github.com/thrust/thrust/downloads /downloads/thrust/thrust/thrust-(\d+.*).zip

## libthrust 1.7.0

=== debian/changelog ===
libthrust (1.7.0-1) unstable; urgency=low

  * New upstream release.  (Closes: #715362)
  * Update watch file.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 10 Jul 2013 12:57:33 +0200

libthrust (1.6.0-2) unstable; urgency=low

  * Set Multi-Arch: allowed.
  * Use canonical Vcs-* URLs.
  * Bump Standards-Version to 3.9.4. No changes needed.
  * Switch to debhelper 9.
  * Update my email address and drop DMUA.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 06 May 2013 01:27:17 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Priority: extra
 Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
 Uploaders:
- Andreas Beckmann <debian@abeckmann.de>,
-Build-Depends: debhelper (>= 8)
-Standards-Version: 3.9.3
+ Andreas Beckmann <anbe@debian.org>,
+Build-Depends: debhelper (>= 9)
+Standards-Version: 3.9.4
 Homepage: http://thrust.github.com/
-Vcs-Svn: svn://svn.debian.org/pkg-nvidia/packages/libthrust/trunk
-Vcs-Browser: http://svn.debian.org/wsvn/pkg-nvidia/packages/libthrust/
-DM-Upload-Allowed: yes
+Vcs-Svn: svn://anonscm.debian.org/pkg-nvidia/packages/libthrust/trunk
+Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-nvidia/packages/libthrust/
 
 Package: libthrust-dev
 Architecture: all
+Multi-Arch: allowed
 Depends: ${misc:Depends}
 Suggests: nvidia-cuda-toolkit
 Description: Thrust - Parallel Algorithms Library

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

get-orig-source:
	uscan --verbose --force-download --rename --repack

=== debian/watch ===
version=3

https://thrust.github.com/ .*/thrust-(\d+.*).zip

## libthrust 1.8.1

=== debian/changelog ===
libthrust (1.8.1-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 05 May 2015 04:25:40 +0200

libthrust (1.8.0-1) experimental; urgency=medium

  * New upstream release.  (Closes: #775260)
  * Packaging has been converted to GIT. Update Vcs-* URLs.
  * Bump Standards-Version to 3.9.6. No changes needed.
  * get-orig-source: Repack to .tar.xz.
  * Update debian/copyright.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 27 Jan 2015 03:46:04 +0100

libthrust (1.7.0-2) unstable; urgency=low

  * Set Multi-Arch: foreign.  (Closes: #735442)
  * Bump Standards-Version to 3.9.5. No changes needed.
  * Update d/copyright: upstream moved some files.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 27 Sep 2014 18:26:58 +0200

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,14 @@
 Uploaders:
  Andreas Beckmann <anbe@debian.org>,
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://thrust.github.com/
-Vcs-Svn: svn://anonscm.debian.org/pkg-nvidia/packages/libthrust/trunk
-Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-nvidia/packages/libthrust/
+Vcs-Git: git://anonscm.debian.org/pkg-nvidia/libthrust.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-nvidia/libthrust.git
 
 Package: libthrust-dev
 Architecture: all
-Multi-Arch: allowed
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Suggests: nvidia-cuda-toolkit
 Description: Thrust - Parallel Algorithms Library

=== debian/rules ===
--- 
+++ 
@@ -7,4 +7,4 @@
 	dh $@ 
 
 get-orig-source:
-	uscan --verbose --force-download --rename --repack
+	uscan --verbose --force-download --rename --repack --compression xz

## libthrust 1.8.2

=== debian/changelog ===
libthrust (1.8.2-1) unstable; urgency=medium

  * New upstream release.
  * Update Homepage and download URLs.
  * Switch to debhelper compat level 11.
  * Set Priority to optional.
  * Bump Standards-Version to 4.1.3.
  * Switch Vcs-* URLs to salsa.debian.org.
  * Set Rules-Requires-Root: no.
  * Add debian/upstream/metadata.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 26 Feb 2018 11:49:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: libthrust
 Section: libdevel
-Priority: extra
+Priority: optional
 Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
 Uploaders:
  Andreas Beckmann <anbe@debian.org>,
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.6
-Homepage: http://thrust.github.com/
-Vcs-Git: git://anonscm.debian.org/pkg-nvidia/libthrust.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-nvidia/libthrust.git
+Build-Depends:
+ debhelper (>= 11~),
+Rules-Requires-Root: no
+Standards-Version: 4.1.3
+Homepage: https://github.com/thrust/thrust
+Vcs-Browser: https://salsa.debian.org/nvidia-team/libthrust
+Vcs-Git: https://salsa.debian.org/nvidia-team/libthrust.git
 
 Package: libthrust-dev
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #export DH_VERBOSE=1
 
 %:
-	dh $@ 
+	dh $@
 
 get-orig-source:
 	uscan --verbose --force-download --rename --repack --compression xz

=== debian/watch ===
version=3

https://github.com/thrust/thrust/releases .*/thrust-(\d+.*).zip
